#ifndef SCENEMANAGER_H
#define SCENEMANAGER_H
#include <string>
#include <fileio.h>
class Scene;

/**
 * Загружает набор сцен
 * @param storage_file имя файла с описанием набора сцен
 * @param video_name имя видео устройства
 * @param fmanager указатель на менеджер файлов. Данный менеджер будет сохранен для внутреннего использования
 * @return true при успехе
 * @author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
 * @date 01.06.2007
 */
#define MAX_EVENTS_AT_TIME 1000
bool load_scenes ( std::string storage_file, std::string video_name, FileIO::FileManager *fmanager );

void process_scene ( std::string start_scene );
void set_next_scene ( std::string next_scene );
Scene* get_scene ( std::string scene_name );
void init(std::string video_name );

#endif
