//
// C++ Implementation: fpscounter
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "fpscounter.h"
#include "text.h"
#include "video_int.h"
#include "video.h"
#include "storage.h"
#include "config.h"
#include "sceneobjectfabric.h"
#include "textrenderer.h"
#include "signal_manager.h"
#include <time.h>
#include <stdio.h>
        
ObjectFabric<FPSCounter> FPSCounterFabric;


bool FPSCounter::real_load ( Scene *scn, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager )
{
 		last_time = 0;
    	return true;
}

void FPSCounter::draw()
{
    if (!last_time)
    {
        last_time = time(0);
    }
    unsigned int ctime = time(0);
    Video_Interface *vid=video_get_interface ( _video_name_ );
    if ( !vid )
    {
        _set_error("Can't get video interface:"+video_error());
        return;
    }
    if (ctime>last_time+1)
    {
        int ctime = time(0);
        char textbuf[20];
        snprintf(textbuf, 20, " %.1f", (float)current_frame/(float)(ctime - last_time));
        current_frame = 0;
        last_time = ctime;
        text = this->pre_text;
        text += textbuf;
        
        Text_Renderer *renderer;
        renderer=textrenderer_get(renderer_type);
	VideoColor clr;
	clr.set_color( color );
        if ( !renderer )
        {
            _set_error("Can't get renderer:"+textrenderer_error());
            return;
        }
        if ( !renderer->render_text_line( _video_name_, font, text, clr, font_size, _object_name_, _scene_name_, true ) )
        {
            _set_error ( "Can't render text:"+renderer->_get_error() );
            return;
        }
        if(!vid->_create_sprite(_object_name_, _scene_name_, _object_name_, _scene_name_, true))
        {
            _set_error("Can't create sprite: "+vid->_get_error());
            return;
        }

        Video_Sprite *spr=vid->_get_sprite ( _object_name_, _scene_name_);
        if(!spr)
        {
            _set_error("Can't get sprite: "+vid->_get_error());
            return;
        }
        spr->_set_base_point ( x_base, y_base );
        spr->_set_coord(x, y);
    }
    vid->_add_sprite ( _object_name_, _scene_name_ );
}

bool FPSCounter::_on_new_frame_handler()
{
	++current_frame;
	return false;
}
