#include "image.h"
#include "video_int.h"
#include "video.h"
#include "storage.h"
#include "config.h"
#include "imageloader.h"
#include "sceneobjectfabric.h"
#include <iostream>

ObjectFabric<Image> ImageFabric;

void Image::draw ( )
{
	Video_Interface *vid=video_get_interface ( _video_name_ );
	if ( !vid ) return;
	vid->_add_sprite ( _object_name_, _scene_name_ );
}
bool Image::real_load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager )
{
	Video_Interface *vid=video_get_interface ( _video_name_ );
	if ( !vid )
	{
		_set_error("Can't get video interface:"+video_error());
		return false;
	}
	bool load_state;
	if( image_file.empty())
	{
		_set_error("Can't load image:"+imageloader_error());
		return false;
	}
	if(loader=="")
		load_state=imageloader_loadimage_noext ( _video_name_, image_file, _scene_name_, _object_name_, fmanager, true );
	else 
		load_state=imageloader_loadimage ( loader,_video_name_, image_file, _scene_name_, _object_name_, fmanager, true );
	if ( !load_state ) 
	{
		_set_error("Can't load image:"+imageloader_error());
		return false;
	}
	if(!vid->_create_sprite(_object_name_, _scene_name_, _object_name_, _scene_name_, true))
	{
		_set_error("Can't create sprite: "+vid->_get_error());
		return false;
	}
	Video_Sprite *spr=vid->_get_sprite ( _object_name_, _scene_name_);
	if(!spr)
	{
		_set_error("Can't get sprite: "+vid->_get_error());
		return false;
	}
	spr->_set_base_point ( x_base, y_base );
	spr->_set_coord(x, y);
	return true;
}
