#include "text.h"
#include "video_int.h"
#include "video.h"
#include "storage.h"
#include "config.h"
#include "sceneobjectfabric.h"
#include "textrenderer.h"

ObjectFabric<Text> TextFabric;

void Text::draw ( )
{
	Video_Interface *vid=video_get_interface ( _video_name_ );
	if ( !vid ) return;
	vid->_add_sprite ( _object_name_, _scene_name_ );
}

bool Text::real_load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager )
{
	VideoColor clr;
	clr.set_color(color);
	Video_Interface *vid=video_get_interface ( _video_name_ );
	if ( !vid )
	{
		_set_error(std::string(__FILE__)+": Can't get video interface:"+video_error());
		return false;
	}

	Text_Renderer *renderer = textrenderer_get(renderer_type);
	if ( !renderer )
	{
		_set_error(std::string(__FILE__)+": Can't get renderer:"+textrenderer_error());
		return false;
	}
	if( !renderer->render_text_line ( _video_name_, font, text, clr, font_size, _object_name_, _scene_name_, true ))
	{
		_set_error(std::string(__FILE__)+": Can't render text:"+renderer->_get_error());
		return false;
	}
	if(!vid->_create_sprite(_object_name_, _scene_name_, _object_name_, _scene_name_, true))
	{
		_set_error(std::string(__FILE__)+": Can't create sprite: "+vid->_get_error());
		return false;
	}

	Video_Sprite *spr=vid->_get_sprite ( _object_name_, _scene_name_);
	if(!spr)
	{
		_set_error(std::string(__FILE__)+": Can't get sprite: "+vid->_get_error());
		return false;
	}
	spr->_set_base_point ( x_base, y_base );
	spr->_set_coord(x, y);
	return true;
}

