#include "window.h"
#include "scene.h"
ObjectFabric<Window> WindowFabric;


DEFINE_SLOT ( Window, _on_scene_reinit )
{
	_internal_scene_->slot__on_activate(args);
	_internal_scene_->reinit();
	return false;
}
DEFINE_SLOT ( Window, _on_activate )
{
	_internal_scene_->slot__on_mouse_press(args);
	return false;
}
DEFINE_SLOT ( Window, _on_deactivate )
{
	_internal_scene_->slot__on_deactivate(args);
	return false;
}
DEFINE_SLOT ( Window, _on_key_press )
{
/*	Signal sgn;
	sgn.set_name("Video->keyboard_press");
	sgn.set_params(args);
	sgn.rise();*/
	return false;
}
DEFINE_SLOT ( Window, _on_key_release )
{
	/*Signal sgn;
	sgn.set_name("Video->keyboard_release");
	sgn.set_params(args);
	sgn.rise();*/
	return false;
}
DEFINE_SLOT ( Window, _on_character )
{
/*	Signal sgn;
	sgn.set_name("Video->character");
	sgn.set_params(args);
	sgn.rise();*/
	return false;	
}
DEFINE_SLOT ( Window, _on_mouse_release )
{
	return false;
}
bool Window::real_load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager)
{
	_internal_scene_ = new Scene;
	_internal_scene_->set_name(object_name);
	_internal_scene_->set_file_manager(fmanager);
	_internal_scene_->set_storage_file(internal_scene_file);
	_internal_scene_->set_height(height);
	_internal_scene_->set_width(width);
	_internal_scene_->set_base_x(x_base);
	_internal_scene_->set_base_y(y_base);
	_internal_scene_->set_x(x);
	_internal_scene_->set_y(y);
	_internal_scene_->set_video_name(_video_name_);
	_internal_scene_->set_parent(scene);
	
	return _internal_scene_->load_scene();
}
void Window::draw( )
{
	Image::draw();
	_internal_scene_->draw();
}
Window::~Window()
{
	if(_internal_scene_)delete _internal_scene_;
}
void Window::unregister_slots()
{
	Image::unregister_slots();
	_internal_scene_->slot__on_deactivate(0);
}

