#include "fonts.h"
#include "ui_fonts.h"
#include <QFileDialog>
#include "textrenderer.h"
#include <iostream>

Fonts::Fonts(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Fonts)
{
    ui->setupUi(this);
}

Fonts::~Fonts()
{
    delete ui;
}

void Fonts::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Fonts::on_font_open_released()
{
    QFileDialog dialog;
    dialog.setDefaultSuffix ( "ttf" );
    dialog.setNameFilter ( tr ( "True type font (*.ttf)" ) );
    dialog.setLabelText ( QFileDialog::Accept, tr ( "Load font" ) );
    dialog.setFileMode ( QFileDialog::ExistingFile );
    dialog.setAcceptMode ( QFileDialog::AcceptOpen);
    dialog.setViewMode ( QFileDialog::Detail );
    if ( dialog.exec() )
    {
         ui->font_path->setText(dialog.selectedFiles()[0]);
         if(!ui->font_alias->text().isEmpty())
             if(!ui->font_path->text().isEmpty())ui->font_add->setEnabled(true);
         else ui->font_add->setEnabled(false);
    }
}

void Fonts::on_font_alias_textChanged(QString )
{
    if(!ui->font_alias->text().isEmpty())
        if(!ui->font_path->text().isEmpty())ui->font_add->setEnabled(true);
    else ui->font_add->setEnabled(false);
}

void Fonts::on_font_add_released()
{
    Text_Renderer *renderer = textrenderer_get("ttf");
    if(!renderer)
    {
        std::cerr<<"Error getting text renderer:"<<textrenderer_error()<<std::endl;
        return;
    }
    if(!renderer->init_font(ui->font_alias->text().toUtf8().data(), ui->font_path->text().toUtf8().data(), fmanager))
    {
        std::cerr<<"Error loading fond: "<<renderer->_get_error()<<std::endl;
    }
    QTreeWidgetItem *item = new QTreeWidgetItem;
    item->setText(0, ui->font_alias->text());
    item->setText(1, ui->font_path->text());
    ui->treeWidget->addTopLevelItem(item);
}
