#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <fileio.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <ctime>
#include <fileio.h>
#include <set>
#include <QThread>


#include "fonts.h"
#include "config.h"
#include "video.h"
#include "imageloader.h"
#include "textrenderer.h"
#include "scenemanager.h"
#include "sceneobjectfabric.h"


namespace Ui
{
    class MainWindow;
}
class MyThread : public QThread
 {
 public:
     void run();
     bool init();
     FileIO::FileManager *filemanager;
 };
class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

private:
    Fonts *fonts;
    Ui::MainWindow *ui;
    FileIO::FileManager *filemanager;
    MyThread *thread;
    std::map<std::string, std::string> config_map;
    std::set<std::string> objects;
    bool fill_object_config(QString object_name, QString class_name);

private slots:
    void on_actionFonts_triggered();
    void on_objectName_textChanged(QString );
    void on_ObjectList_currentIndexChanged(QString );
    void on_AddedObjects_itemSelectionChanged();
    void on_AddObject_released();
    void on_actionLoad_object_set_triggered();
};

#endif // MAINWINDOW_H
