#ifndef OBJECTTREESHOWER_H
#define OBJECTTREESHOWER_H

#include <fileio.h>
#include <QtGui/QWidget>
#include <QTreeWidget>
#include "config_classes.h"


namespace Ui {
    class ObjectTreeShower;
}

class ObjectTreeShower : public QWidget {
    Q_OBJECT
public:
    ObjectTreeShower(QWidget *parent = 0);
    ~ObjectTreeShower();
    void show_object_params(std::string oname, std::string otype, std::map<std::string, std::string> *conf_map_);
    void set_fmanager(FileIO::FileManager *fmanager){filemanager=fmanager;}

protected:
    void changeEvent(QEvent *e);
    void fill_one_object(Config_Interface *intf, QTreeWidgetItem *top);
    Config_Interface* get_intf_by_name(std::string name);
    FileIO::FileManager *filemanager;

private:
    Ui::ObjectTreeShower *m_ui;
    QTreeWidgetItem *currently_edited_item;
    std::map<std::string, std::string> *conf_map;
    void set_config_value(QTreeWidgetItem *item, std::string value);

private slots:
    void on_SetValue_released();
    void on_ObjectParams_itemActivated(QTreeWidgetItem* item, int column);
};

#endif // OBJECTTREESHOWER_H
