//
// C++ Implementation: me_opengl_video_surface
//
// Description:
//
//
// Author: Messenger of death <Messengerofdeath@gmail.com>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifdef HAVE_CONFIG_H
#include <conf_config.h>
#endif

#ifdef WIN32
#ifdef HAVE_WINDOWS_H
#include <windows.h>
#endif
#endif

#include <math.h>
#include <GL/glew.h>
#include "video_GL_glfw.h"
#include <iostream>
#include <string.h>
#ifdef Revision
#undef Revision
#endif
#define Revision "GL_video_surface.cpp $Revision: 1.1 $"
		
OpenGL_Surface::OpenGL_Surface ( ) :
		Video_Surface(), _tex_id_(0), u_max(0.0), v_max(0.0)
{
}
OpenGL_Surface::~OpenGL_Surface()
{
	glDeleteTextures ( 1, (GLuint*)&_tex_id_ );
}
void OpenGL_Surface::_update_ ( )
{
	if(_tex_id_!=0)glDeleteTextures ( 1, (GLuint*)&_tex_id_ );
	glGenTextures(1, (GLuint*)&_tex_id_);
	
	glBindTexture ( GL_TEXTURE_2D, _tex_id_ );
			
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP );
	glTexParameteri ( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP );
	glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	glTexParameterf ( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
	glTexImage2D ( GL_TEXTURE_2D, 0, 4, real_width, real_height, 0, GL_RGBA, GL_UNSIGNED_BYTE, _surface_);

	_need_update_=false;

}
bool OpenGL_Surface::_create_ ( Uint16 w, Uint16 h )
{
	_need_update_ = true;
	_bpp_ = 4;
	real_width = w;
	real_height = h;
	real_width--;
	real_width |= real_width >> 1;
	real_width |= real_width >> 2;
	real_width |= real_width >> 4;
	real_width |= real_width >> 8;
	real_width |= real_width >> 16;
	real_width++;
	real_height--;
	real_height |= real_height >> 1;
	real_height |= real_height >> 2;
	real_height |= real_height >> 4;
	real_height |= real_height >> 8;
	real_height |= real_height >> 16;
	real_height++;
	_w_ = w;
	_h_ = h;
	v_max = (float)w/(float)real_width;
	u_max = (float)h/(float)real_height;
	_surface_ = new unsigned char[ real_width * real_height * _bpp_ ];
	memset(_surface_, 0, real_width * real_height * _bpp_);
	_Rmask_ = 0xff000000;
	_Gmask_ = 0x00ff0000;
	_Bmask_ = 0x0000ff00;
	_Amask_ = 0x000000ff;
	_alpha_ = ALPHA_CHANNEL;
	return true;
}
int OpenGL_Surface::_get_line_size() const
{
	return real_width * _bpp_;
}
