//
// C++ Interface: ammo
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef AMMO_H
#define AMMO_H

#include <image.h>
#include <string>
#include "signal_manager.h"
#include "me_time.h"
#include "ammo_info.h"
/**
	@author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
*/
class Ammo : public Image
{
	public:
		DECLARE_SLOT ( Ammo, _on_new_cycle );
		VIRTUAL_SLOT ( _on_scene_reinit );

		Ammo ( std::string name );
		~Ammo();
		virtual bool init ( std::string video_name, std::string scene_name, double x, double y, const AmmoInfo &ammo );
		virtual void draw();
	private:
		Signal _check_hit_;
		uint64_t _last_time_;
		Time _timer_;
		int _damage_;
		std::string _image_name_;
};

#endif
