//
// C++ Implementation: ammo_info
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ammo_info.h"
#include "enemyinfo.h"
#include "config.h"
#include "config_classes.h"
#include "video.h"
#include "video_int.h"
#include "imageloader.h"
#include <stdlib.h>

AmmoInfo::AmmoInfo()
{
}


AmmoInfo::~AmmoInfo()
{
}

bool AmmoInfo::load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, FileIO::FileManager *fmanager )
{
	Config_Interface *intf = config_get_interface ( storage_name );
	_image_file = intf->_get_value ( storage_prefix+"image", "" );
	_damage = atol ( intf->_get_value ( storage_prefix+"damage", "" ).c_str() );
	_launch_delay = atof ( intf->_get_value ( storage_prefix+"launch_delay", "" ).c_str() );
	Video_Interface *vid=video_get_interface ( video_name );
	if ( !vid )
	{
		return false;
	}
	bool load_state;
	load_state=imageloader_loadimage ( "png", video_name, _image_file, scene_name, _image_file, fmanager, true );
	if ( !load_state )
	{
		return false;
	}
	return true;
}


