/*
*/
#include "animation.h"
#include "config_classes.h"
#include "config.h"
#include "video.h"
#include "video_int.h"
#include "imageloader.h"
#include <stdlib.h>
#include <iostream>
#include <stdio.h>



bool Animation::load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, FileIO::FileManager *fmanager )
{
	Config_Interface *intf = config_get_interface ( storage_name );
	_animation_size = atol(intf->_get_value(storage_prefix+"AnimationSet->AnimationSize", "").c_str());
	Video_Interface *vid=video_get_interface ( video_name );
	if ( !vid )
	{
		return false;
	}
	
	storage_prefix+="Animation";
	char pref_buf[10];
	for(int z = 1; z <= _animation_size; ++z)
	{
		snprintf(pref_buf, 9, "%d", z);
		
		AnimationFrame tmp;
		tmp.delay = atof(intf->_get_value( storage_prefix + pref_buf + "->Delay", "").c_str());
		tmp.image = intf->_get_value(storage_prefix + pref_buf + "->Image", "");
		_animation_.push_back(tmp);
		//Произведем загрузку картинки
		if( !imageloader_loadimage("png", video_name, tmp.image, scene_name, tmp.image, fmanager, true)) 
		{
			std::cerr<<"Error while loading \""<<tmp.image<<"\": "<<imageloader_error()<<std::endl;
			return false;	
		}
	}
	_was_called = false;
	_current_frame = 0;
	return true;
}


Animation::Animation()
{

}

std::string Animation::operator()()
{
	if(!_was_called)
	{
		_was_called = true;
		_timer.reset();
		return _animation_.begin()->image;
	}
	float dt = _timer.get_elapsed_time_noreset();
	//Если еще не пришло время смены кадра анимации - просто завершим работу
	if(_animation_[_current_frame].delay > dt)return _animation_[_current_frame].image;
	else
	{
		if(++_current_frame >= _animation_size)return "";
		_timer.reset();
		return _animation_[_current_frame].image;
	}
}

Animation::~Animation()
{

}
