/*
*/

#ifndef ANIMATION_H
#define ANIMATION_H
#include <vector>
#include <string>
#include "me_time.h"
#include <fileio.h>

struct AnimationFrame
{
	std::string image;
	float delay;
};
class Animation
{
	public:
		Animation();
		~Animation();
		bool load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, FileIO::FileManager *fmanager );
		/**
		 * Возвращает имя спрайта в зависимости от времени с момента последней смены кадра. Таймер встроенный.
		 * @return имя спрайта
		 */
		std::string operator() (  );
		void reset(){ _current_frame = 0; _was_called = false;}
	private:
		std::vector<AnimationFrame> _animation_;
		int _animation_size;
		int _current_frame;
		Time _timer;
		bool _was_called;
};

#endif // ANIMATION_H
