//
// C++ Interface: ammo
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef ENEMY_H
#define ENEMY_H

#include <image.h>
#include <string>
#include "signal_manager.h"
#include "me_time.h"
#include "enemyinfo.h"
#include "music.h"
/**
	@author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
*/
class Enemy : public Image
{
	public:
		DECLARE_SLOT ( Enemy, _on_new_cycle );
		DECLARE_SLOT ( Enemy, _on_check_hit );
		VIRTUAL_SLOT ( _on_scene_reinit );

		Enemy ( std::string name );
		~Enemy();
		virtual bool set_image ( std::string video_name, const EnemyInfo &enemy_info, std::string scene_name, double x, double y, FileIO::FileManager *fmanager );
		virtual void draw();
		bool die();
		void alive();
                static Effect _effect_;
    private:
		Signal _add_score_;
		Time _timer_;
		Time _chain_timer_;
		Signal _check_enemy_hit_;
		static int _powerup_counter_;
		static int _eammo_counter_;
		int _damage_done_;
		std::string _last_surface_name_;
		EnemyInfo info;
		bool _dieing_state_;
		int _chain_num;
		FileIO::FileManager *_fmanager_;
};

#endif
