#include "enemy_damage_set.h"
#include "config_classes.h"
#include "config.h"
#include "video.h"
#include "video_int.h"
#include "imageloader.h"
#include <stdlib.h>
#include <stdio.h>

bool Enemy_Damage_Set::load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, FileIO::FileManager *fmanager )
{
	Config_Interface *intf = config_get_interface ( storage_name );
	damage_set_size = atol(intf->_get_value(storage_prefix+"DamageSet->DamageCount", "").c_str());
	Video_Interface *vid=video_get_interface ( video_name );
	if ( !vid )
	{
		return false;
	}
	
	storage_prefix+="Damage";
	char pref_buf[10];
	for(int z = 0; z < damage_set_size ; ++z)
	{
		int amount;
		std::string name;
		snprintf(pref_buf, 9, "%d", z);
		amount = atol(intf->_get_value( storage_prefix + pref_buf + "->Amount", "").c_str());
		name = intf->_get_value(storage_prefix + pref_buf + "->Image", "");
		damage_set.insert(make_pair(amount, name));
		//Произведем загрузку картинки
		if( !imageloader_loadimage("png", video_name, name, scene_name, name, fmanager, false)) return false;
	}
	return true;
}

std::string Enemy_Damage_Set::operator[] ( int damage )
{
	std::string *lastname = &damage_set.begin()->second;
	for( std::map<int, std::string>::iterator it = damage_set.begin(); it != damage_set.end(); ++it)
	{
		if(it->first < damage) lastname = &it->second;
		else return *lastname;
	}
	return *lastname;
}

Enemy_Damage_Set::Enemy_Damage_Set()
{

}

Enemy_Damage_Set::~Enemy_Damage_Set()
{

}
