#ifndef ENEMY_DAMAGE_SET_H
#define ENEMY_DAMAGE_SET_H

#include <string>
#include <map>
#include <fileio.h>
/**
 * Сохраняет инвормацию о соответсвии изображения корабля в зависимости от степени его повреждений
 * @author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
 */
class Enemy_Damage_Set
{
	public:
		Enemy_Damage_Set();
		~Enemy_Damage_Set();
		bool load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, FileIO::FileManager *fmanager );
		/**
		 * Возвращает имя спрайта в зависимости от повреждений
		 * @param damage кол-во нанесенных повреждений
		 * @return имя спрайта
		 */
		std::string operator[] ( int damage );
	private:
		std::map<int, std::string> damage_set;
		int damage_set_size;
};

#endif // ENEMY_DAMAGE_SET_H
