//
// C++ Interface: enemyammo
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef SCENEIMAGEENEMYAMMO_H
#define SCENEIMAGEENEMYAMMO_H
#include <image.h>
#include <string>
#include "signal_manager.h"
#include "me_time.h"
#include "ammo_info.h"
#include "eammo_info.h"
/**
	@author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
*/
class EnemyAmmo : public Image
{
	public:
		DECLARE_SLOT ( EnemyAmmo, _on_new_cycle );
		VIRTUAL_SLOT ( _on_scene_reinit );

		EnemyAmmo ( const std::string &name );
		~EnemyAmmo();
		virtual bool init ( std::string video_name, std::string scene_name, double x, double y, const EAmmoInfo &ammo, double target_x, double target_y );
		virtual void draw();
	private:
		Signal _check_enemy_hit_;
		uint64_t _last_time_;
		Time _timer_;
		std::string _image_name_;
		float _x_speed_;
		float _y_speed_;
		float _rot_speed_;
		float _rot_;
		int _damage_;
};

#endif
