/***************************************************************************
 *   Copyright (C) 2007 by Denis A. Birukov   *
 *   Denis A. Birukov@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ENEMYEMITTER_H
#define ENEMYEMITTER_H

#include <sceneobject.h>
#include "sceneobjectfabric.h"
#include <string>
#include "me_time.h"
#include "enemyinfo.h"
#include <map>
#include "enemychance.h"
#include "eammo_info.h"
/**
	@author Denis A. Birukov <Denis A. Birukov@gmail.com>
*/
class EnemyEmitter : public SceneObject
{
	public:
		EnemyEmitter();
		~EnemyEmitter();

		DECLARE_SLOT ( EnemyEmitter, on_new_cycle );
		VIRTUAL_SLOT ( _on_scene_reinit );

		virtual bool load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager );
		virtual void draw();
	private:
		std::string _enemy_config_file_;
		std::string _chanse_config_file_;
		std::string _eammo_config_file_;
		int _chance_count_;
		int _enemy_counter_;
		int _enemy_count_;
		int _eammo_count_;
		float _base_emit_rate_;
		float _emit_rate_;
		float _max_emit_rate_;
		float _emit_change_speed_;
		Time _timer_;
		Time _time_from_start_;
		std::vector<EnemyInfo> _enemyes_;
		std::vector<EAmmoInfo> _ammos_;
		std::map<float, EnemyChance> _chanses;
		std::string _explosion_fx_;
		FileIO::FileManager *_fmanager_;
};

extern ObjectFabric<EnemyEmitter> EnemyEmitterFabric;
#endif
