//
// C++ Implementation: enemyinfo
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "enemyinfo.h"
#include "config.h"
#include "config_classes.h"
#include "video.h"
#include "video_int.h"
#include "imageloader.h"
#include <stdlib.h>
#include <iostream>

EnemyInfo::EnemyInfo()
{
}


EnemyInfo::~EnemyInfo()
{
}

bool EnemyInfo::load ( std::string storage_name, std::string storage_prefix, std::string scene_name, std::string video_name, const EAmmoInfo &info, FileIO::FileManager *fmanager )
{
	Config_Interface *intf = config_get_interface ( storage_name );
	damage_set = intf->_get_value ( storage_prefix+"damage_set", "" );
	animation_set = intf->_get_value ( storage_prefix+"animation_set", "" );
	_hp = atol ( intf->_get_value ( storage_prefix+"hitpoints", "" ).c_str() );
        _speed = atof ( intf->_get_value ( storage_prefix+"speed", "" ).c_str() );
	_drop_chance = atol ( intf->_get_value ( storage_prefix+"drop_chance", "" ).c_str() );
	move_style = atol ( intf->_get_value ( storage_prefix+"move_style", "" ).c_str() );
	can_shoot = atol  ( intf->_get_value ( storage_prefix+"can_shoot", "0" ).c_str() );
	precision = atof  ( intf->_get_value ( storage_prefix+"precision", "" ).c_str() );
	_x_speed = atof  ( intf->_get_value ( storage_prefix+"x_speed", "" ).c_str() );
	_shoot_rate = atol (intf->_get_value ( storage_prefix+"shoot_rate", "" ).c_str() );
	_chain_delay = atof ( intf->_get_value ( storage_prefix+"chain_delay", "0.0" ).c_str() );
	_chain_length = atol (intf->_get_value ( storage_prefix+"chain_length", "0" ).c_str() );
	ammo_info = info;
	
	//Load damage set
	std::cerr<<"DamageSet:"<<damage_set<<std::endl;
	if ( !config_create ( damage_set, "libtextconfig", true ) )
	{
		std::cerr << "Error while trying to create config from libtextconfig: " << config_error() << std::endl;
		return false;
	}
	//Load config
	Config_Interface *DSCI = config_get_interface ( damage_set );
	DSCI->_load ( damage_set, fmanager );
	if(!_damage_set.load(damage_set, "", scene_name, video_name, fmanager))return false;


	//Load animation set
	std::cerr<<"AnimationSet:"<<animation_set<<std::endl;
	if ( !config_create ( animation_set, "libtextconfig", true ) )
	{
		std::cerr << "Error while trying to create config from libtextconfig: " << config_error() << std::endl;
		return false;
	}
	//Load config
	Config_Interface *ASCI = config_get_interface ( animation_set);
	ASCI->_load ( animation_set, fmanager );
	if(!_animation_set.load(animation_set, "", scene_name, video_name, fmanager))return false;

	
	return true;
}


