//
// C++ Implementation: entername
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "entername.h"
#include "signal_manager.h"
#include "scores.h"
#include "textedit.h"
#include <scene.h>
ObjectFabric<EnterName> EnterNameFabric;

EnterName::EnterName()
		: Image(),
		Text(),
		INIT_SLOT ( EnterName, this, _on_activate )
{
}


EnterName::~EnterName()
{
}


bool EnterName::load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager )
{
	Config_Interface *intf = config_get_interface ( storage_name );
	if ( !intf ) return false;
	bool img_state, ttf_state;
	img_state = Image::load ( scene, storage_name, storage_prefix, scene_name, object_name, fmanager );
	ttf_state = Text::load ( scene, storage_name, storage_prefix, scene_name, object_name, fmanager );
	_fmanager_ = fmanager;

	return img_state | ttf_state;
}
void EnterName::draw ()
{
	Image::draw();
	Text::draw();
}
DEFINE_SLOT ( EnterName, _on_activate )
{
	TextEdit *text = dynamic_cast<TextEdit*>(_scene_->get_object("name_field"));
	if(!text)
	{
		return false;
	}
	register_new_score(text->_get_text(), _fmanager_);
	Scene *scn = get_scene("game_scene");
	if(!scn)set_next_scene("start_game");
	SceneObject *obj = scn->get_object("scores_add_window");
	if(obj)
	{
		obj->_set_show(false);
		obj->unregister_slots();
	}
	obj = scn->get_object("scores_show_local_window");
	if(obj)obj->_set_show(true);
	obj = scn->get_object("scores_show_remote_window");
	if(obj)obj->_set_show(true);
	obj = scn->get_object("scores_show_menu_window");
	if(obj)obj->_set_show(true);
	
	return true;
}
