//
// C++ Implementation: game_scene
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "game_scene.h"
#include "defines.h"
#include "signal_manager.h"
#include "me_signal.h"
#include "video_int.h"
#include "video.h"
#include "config.h"

SceneFabrics<GameScene> GameSceneFabrick;

GameScene::GameScene()
		:
		Scene(),
		INIT_SLOT ( GameScene, this, _on_mouse_press )
{
}


GameScene::~GameScene()
{
}

bool GameScene::scene_loaded()
{
	return Scene::scene_loaded();
}

bool GameScene::draw()
{
	return Scene::draw();
}

bool GameScene::load_scene()
{
	bool state = Scene::load_scene();
        if(!state)return state;
        
        if ( !config_create ( "SceneLoader", "libtextconfig", true ) )
        {
            std::cerr<< "Error while trying to create config from libtextconfig: " << config_error() << std::endl;
            return false;
        }
        Config_Interface *intf = config_get_interface ( "SceneLoader" );
        if ( !intf )
        {
            std::cerr<< "Error with config";
            return false;
        }
        intf->_load ( _storage_file_, _fmanager_ );
        _music_file_ = intf->_get_value ( "Scene->music", "" );
        _mus_.load(_music_file_);
        return true;
}

DEFINE_SLOT ( GameScene, _on_mouse_press )
{
	_shoot_.rise();
	Scene::slot__on_mouse_press(args);
	return false;
}
void GameScene::init_signals()
{
	_shoot_.set_name ( _name_+"->shoot" );
	Scene::init_signals();
}

DEFINE_SLOT ( GameScene, _on_activate )
{
    _mus_.play();
    return Scene::slot__on_activate(args);
}
DEFINE_SLOT ( GameScene, _on_deactivate )
{
    _mus_.pause();
    return Scene::slot__on_deactivate(args);
}
