//
// C++ Interface: herospaceship
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef HEROSPACESHIP_H
#define HEROSPACESHIP_H

#include <image.h>
#include <string>
#include "ammo_info.h"
#include "me_time.h"
#include "me_signal.h"
#include "animation.h"

/**
	@author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
*/
class HeroSpaceship : public Image
{
	public:
		HeroSpaceship();
		DECLARE_SLOT ( HeroSpaceship, _on_mouse_move );
		DECLARE_SLOT ( HeroSpaceship, _on_shoot );
		DECLARE_SLOT ( HeroSpaceship, _on_check_enemy_hit );
		DECLARE_SLOT ( HeroSpaceship, _on_add_score );
		DECLARE_SLOT ( HeroSpaceship, _on_check_hero_pickup );
		VIRTUAL_SLOT ( _on_scene_reinit );

		~HeroSpaceship();

		virtual bool load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager );
		virtual void draw();
		virtual void disconnect_signals(bool is_disconnect_on_load);
		int get_current_score(){return _current_score_;}
		bool die();

	private:
		std::string _ammo_config_file_;
		uint32_t _ammo_count_;
		uint32_t _ammo_counter_;
		uint32_t _current_ammo_;
		uint32_t _default_ammo_;
		std::vector<AmmoInfo> _ammos_;
		Time _ammo_shoot_timer_;
        Time _timer_;
		int _current_score_;
        double _move_speed_;
		int _hp_;
		int _damage_;
		Signal set_score;
		Signal set_damage;
		bool _dieing_state_;
		Animation _animation_set;
		std::string _last_surface_name_;
		std::string _base_surface_;

};

extern ObjectFabric<HeroSpaceship> HeroSpaceshipFabric;

#endif
