//
// C++ Interface: menubackground
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef MENUBACKGROUND_H
#define MENUBACKGROUND_H
#include "sceneobject.h"
#include "sceneobjectfabric.h"
#include <string>
#include "video_int.h"
#include "me_time.h"

/**
	@author Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>
*/
struct MenuBackgroundData
{
	float x;
	float y;
	VideoColor color;
	int alfa_direction; //0 - не менять, 1- гасить, 2- зажигать
};
class MenuBackground : public SceneObject
{
	public:
		MenuBackground();
		~MenuBackground();
		virtual bool load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager );
		virtual void draw();

	private:
		DECLARE_SLOT ( MenuBackground, _on_new_frame);
		std::string _fname_;
		int _count_;
		int _size_;
		MenuBackgroundData *_data_;
		Time tm;
		Time hidestar_delay;
};
extern ObjectFabric<MenuBackground> MenuBackgroundFabric;
#endif
