#pragma once
#include <string>
#include "sceneobjectfabric.h"
#include "text.h"
#include "image.h"
#include "scenemanager.h"
#include "scene.h"
#include "herospaceship.h"


class NetSync: virtual public Text, virtual public Image
{
	public:
//public slots
		VIRTUAL_SLOT ( _on_scene_reinit );
		VIRTUAL_SLOT(_on_mouse_release )
		{
			float x_pos;
			float y_pos;
			float dx;
			float dy;
			int64_t button_state;
			try
			{
				button_state= args->int_args.at(0);
				x_pos = args->float_args.at(0);
				y_pos = args->float_args.at(1);
				dx = args->float_args.at(2);
				dy = args->float_args.at(3);
			}
			catch(...){return true;};
			return _on_mouse_release_handler(x, y, dx, dy, button_state);
		}
		bool _on_mouse_release_handler(float x_pos, float y_pos, float dx, float dy, int64_t button_state);
//public functions
		 bool load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager)
		{
			_scene_name_ = scene_name;
			_object_name_ = object_name;
			_storage_name_ = storage_name;
			_storage_prefix_ = storage_prefix;
			Config_Interface *intf = config_get_interface ( storage_name );
			if ( !intf )
			{
				_set_error ( "Can't get config interface:" + config_error() );
				return false;
			}
			bool state[2];
			state[0]=Text::load(scene, storage_name, storage_prefix, scene_name, object_name, fmanager);
			state[1]=Image::load(scene, storage_name, storage_prefix, scene_name, object_name, fmanager);
			bool s=false;
			for(int a=0;a<2; ++a)
				if(state[a]){s=state[a]; break;}
			if(!s)return false;
			ok_color = strtoul(intf->_get_value(storage_prefix+"net_sync->ok_color", "0x00ff00ff").c_str(), (char **) NULL, 0);
			bad_color = strtoul(intf->_get_value(storage_prefix+"net_sync->bad_color", "0xff0000ff").c_str(), (char **) NULL, 0);

			
			_fmanager_ = fmanager;
			return true;
		}
		virtual void draw()
		{
			Text::draw();
			Image::draw();
		}
		NetSync() : Text(), Image(){}
		~NetSync(){}
		private:
			void generate_text(const std::string &text, unsigned int color);
			FileIO::FileManager *_fmanager_;
			unsigned int ok_color;
			unsigned int bad_color;
};

extern ObjectFabric<NetSync> NetSyncFabric;
