#pragma once
#include <fileio.h>
#include <physfs.h>

class CreatePhysfsFile
{
	public:
		FileIO::File* operator()( const std::string &filename, FileIO::READ_MODE mode );
		void add_search_path(const std::string &path, bool is_insert_first = true);
		CreatePhysfsFile( char *argv0);
};

class PhysfsFile : public FileIO::File
{
	public:
		virtual int read ( void *buf, int size );
		virtual int write ( const void *buf, int size );
		virtual void seek ( int64_t position, FileIO::FILE_POSITION whence = FileIO::POS_CUR );
		virtual void *mmap();
		virtual void reset();
		virtual uint64_t get_file_size() const;

		virtual ~PhysfsFile();
	protected:
		PhysfsFile ( const std::string &filename, FileIO::READ_MODE mode, PHYSFS_file *file );
		std::string _filename_;
		FileIO::READ_MODE _file_mode_;
		uint64_t _file_size_;
		PHYSFS_file *_file_;
		char *_map_cache_;
		friend class CreatePhysfsFile;
};


