#include <scores.h>
#include "config.h"
#include "config_classes.h"
#include <map>
#include <stdlib.h>
#include <functional>
#include <iostream>
#include <stdio.h>
std::string last_name;
class ScoreChecker : public config_functor
{
		int _tested_score_;
		bool _is_bigger_;
	public:
		ScoreChecker ( int tscore ) : _tested_score_ ( tscore ), _is_bigger_ ( false ) {};
		bool isBigger() {return _is_bigger_;}

		void operator() ( std::pair<std::string, std::string> value )
		{
			if ( value.first.find ( "->Score" ) != std::string::npos )
			{
				int tscr = atol ( value.second.c_str() );
				if ( tscr<_tested_score_ ) _is_bigger_ = true;
			}
		}
};

bool add_score ( int value )
{
	Config_Interface *scores = config_get_interface ( "GameScores" );
	if ( !scores ) return false;
	//Проверим, попадает ли данный рекорд в таблицу рекордов. Для этого проверим, есть ли хотябы 1 рекорд меньше нового
	ScoreChecker score_checker ( value );
	scores->for_each ( &score_checker );
	if ( score_checker.isBigger() )
	{
		char record[10];
		snprintf ( record, 9, "%d", value );
		scores->_set_value ( "NewRecord", record );
		return true;
	}
	return false;
}

void unicode2utf8(const std::vector<int> &unicode, std::string &utf8)
{
	for(std::vector<int>::const_iterator it=unicode.begin(); it!=unicode.end(); ++it)
	{
		if ( *it < 0x0080 )utf8.push_back((unsigned char) *it);
		else if ( *it < 0x0800 ) 
		{
			utf8.push_back(0xC0 | (( *it ) >> 6 ));
			utf8.push_back(0x80 | (( *it ) & 0x3f ));
		}
		else {
			utf8.push_back(0xE0 | (( *it ) >> 12 ));
			utf8.push_back(0x80 | (( ( *it ) >> 6 ) & 0x3f ));
			utf8.push_back(0x80 | (( *it ) & 0x3f ));
		}
	}
}

void register_new_score ( std::vector<int> val, FileIO::FileManager *fmanager )
{
	Config_Interface *scores = config_get_interface ( "GameScores" );
	if ( !scores ) return;
	int nv = atol ( scores->_get_value ( "NewRecord", "0" ).c_str() );
	scores->_del_value ( "NewRecord", false );

	last_name.clear();
	unicode2utf8(val, last_name);
	
	int score_amount = atol ( scores->_get_value ( "Scores->count", "10" ).c_str() );
	std::multimap<int, std::string, std::greater<int> > scor;
	std::multimap<int, std::string>::iterator scor_it;
	char prefix[100];
	for ( int a=0;a<score_amount;++a )
	{
		snprintf ( prefix, 99, "Score%d->Score", a );
		int tval = atol ( scores->_get_value ( prefix, "0" ).c_str() );
		snprintf ( prefix, 99, "Score%d->Name", a );
		std::string tname = scores->_get_value ( prefix, "" );
		scor.insert ( make_pair ( tval, tname ) );
	}
	scor.insert ( make_pair ( nv, last_name ) );
	scor_it = scor.begin();
	char cval[100];
	for ( int a=0;a<score_amount;++a )
	{
		snprintf ( prefix, 99, "Score%d->Score", a );
		snprintf ( cval, 99, "%d", scor_it->first );
		scores->_set_value ( prefix, cval, true );
		snprintf ( prefix, 99, "Score%d->Name", a );
		scores->_set_value ( prefix, scor_it->second, true );
		++scor_it;
	}
	std::string fname ( "res/data/scores.dat" );
	scores->_save ( fname, fmanager);
}

