//
// C++ Implementation: scoresshower
//
// Description:
//
//
// Author: Messenger of death aka Denis A. Birukov <messengerofdeath@gmail.com>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "scoresshower.h"
#include <iostream>
#include "video_int.h"
#include "video.h"
#include "textrenderer.h"
#include <stdio.h>
#include "scenemanager.h"
#include "scene.h"
#include "herospaceship.h"

ObjectFabric<ScoresShower> ScoresShowerFabric;
ScoresShower::ScoresShower()
		: Text()
{
}


ScoresShower::~ScoresShower()
{
}
void ScoresShower::draw()
{
	Config_Interface *scores = config_get_interface ( _source_ );
	if ( !scores ) return;
	int score_amount = atol ( scores->_get_value ( "Scores->count", "10" ).c_str() );
	char prefix[100];
	text.clear();
	for ( int a = 0;a < score_amount;++a )
	{
		snprintf ( prefix, 99, "Score%d->Name", a );
		text += scores->_get_value ( prefix, "none" );
		text += ":";
		snprintf ( prefix, 99, "Score%d->Score", a );
		text += scores->_get_value ( prefix, "0" );
		text += "\\n";
	}
	
	Scene *game_scene = get_scene("game_scene");
	SceneObject *obj = game_scene->get_object("hero");
	if(obj)
	{
		HeroSpaceship *score = dynamic_cast<HeroSpaceship*>(obj);
		text += "\\n\\n";
		text+="Вы набрали:";
		char buf[20];
		snprintf(buf, 20, "%d",score->get_current_score());
		text+= buf;
	}
	
	Video_Interface *vid = video_get_interface ( _video_name_ );
	if ( !vid )
	{
		_set_error ( "Can't get video interface:" + video_error() );
		return;
	}

	Text_Renderer *renderer;
	renderer = textrenderer_get ( renderer_type );
	if ( !renderer )
	{
		_set_error ( "Can't get renderer:" + textrenderer_error() );
		return;
	}
	VideoColor clr;
	clr.set_color( color );
	if ( !renderer->render_text_line ( _video_name_, font, text, clr, font_size, _object_name_, _scene_name_, true ) )
	{
		_set_error ( "Can't render text:" + renderer->_get_error() );
		return;
	}
	if ( !vid->_create_sprite ( _object_name_, _scene_name_, _object_name_, _scene_name_, true ) )
	{
		_set_error ( "Can't create sprite: " + vid->_get_error() );
		return;
	}

	Video_Sprite *spr = vid->_get_sprite ( _object_name_, _scene_name_ );
	if ( !spr )
	{
		_set_error ( "Can't get sprite: " + vid->_get_error() );
		return;
	}

	spr->_set_base_point ( x_base, y_base );
	spr->_set_coord ( x, y );
	vid->_add_sprite ( _object_name_, _scene_name_ );

}
bool ScoresShower::load ( Scene *scene, std::string storage_name, std::string storage_prefix, std::string scene_name, std::string object_name, FileIO::FileManager *fmanager )
{
	if ( !Text::load ( scene, storage_name, storage_prefix, scene_name, object_name, fmanager ) ) return false;
	storage_prefix += "scores_shower->";
	Config_Interface *intf = config_get_interface ( storage_name );
	if ( !intf )
	{
		_set_error ( "Can't get config interface:" + config_error() );
		return false;
	}
	_source_ = intf->_get_value ( storage_prefix + "source", "" );


	return true;
}


